//------------------------------------------------------------------------------
//
//  npctrl.c
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#include "npdata.h"
#include "npio.h"
#include "npctrl.h"

#include "io/npglut.h"
#include "ctrl/npengine.h"


//------------------------------------------------------------------------------
void npInitCtrl (void* dataRef)
{
	npInitEngine (dataRef);
}

//------------------------------------------------------------------------------
void npCloseCtrl (void* dataRef)
{
	npCloseEngine (dataRef);
}

//------------------------------------------------------------------------------
int npMainAppLoop (void* dataRef)
{
	int err = 0;

#ifdef _LINUX_
//	MainAppLoopLinux();
#endif

#ifdef _MSW_
//	MainAppLoopMSW();
	npInitGlut (0, 0, dataRef);
	npMainAppLoopGlut (dataRef);
#endif

#ifdef _OSX_
	//	MainAppLoopOSX();
#endif


	return err;
}


//------------------------------------------------------------------------------
void npCtrlCommand (int command, void* dataRef)
{
	pData data = (pData) dataRef;

	NPplotPtr plot = data->map.plot[data->map.plotIndex];

	switch (command)
	{
		case kFullScreenExit : npGlutFullScreenExit(); break;

		case kGraphXdecrease : plot->translateRate.x = -0.1f; break;
		case kGraphXdecreaseOff : plot->translateRate.x = 0.0f; break;
		case kGraphXincrease : plot->translateRate.x = 0.1f; break;
		case kGraphXincreaseOff : plot->translateRate.x = 0.0f; break;

		case kGraphYdecrease : plot->translateRate.y = -0.1f; break;
		case kGraphYdecreaseOff : plot->translateRate.y = 0.0f; break;
		case kGraphYincrease : plot->translateRate.y = 0.1f; break;
		case kGraphYincreaseOff : plot->translateRate.y = 0.0f; break;

		case kGraphZdecrease : plot->translateRate.z = -0.1f; break;
		case kGraphZdecreaseOff : plot->translateRate.z = 0.0f; break;
		case kGraphZincrease : plot->translateRate.z = 0.1f; break;
		case kGraphZincreaseOff : plot->translateRate.z = 0.0f; break;
	}
}


//------------------------------------------------------------------------------
void npCtrlUpdateData (void* dataRef)
{
	npDataUpdate (dataRef);
}


//------------------------------------------------------------------------------
void npCtrlUpdateEngine (void* dataRef)
{
	npEngineUpdate (dataRef);
}


